
#include "html.h"
#include <sstream>
#include "sswrite.h"

std::string encode_html_entity(char const *ptr, size_t len)
{
	std::stringstream out;
	if (ptr) {
		while (len > 0) {
			char c = *ptr;
			if (c == '&') {
				static char const *p = "&amp;";
				sswrite(&out, p);
			} else if (c == '<') {
				static char const *p = "&lt;";
				sswrite(&out, p);
			} else if (c == '>') {
				static char const *p = "&gt;";
				sswrite(&out, p);
			} else if (c == '\"') {
				static char const *p = "&quot;";
				sswrite(&out, p);
			} else if (c == '\'') {
				static char const *p = "&apos;";
				sswrite(&out, p);
			} else {
				out.put(c);
			}
			ptr++;
			len--;
		}
	}
	return out.str();
}

