
#include "html.h"
#include <sstream>
#include "sswrite.h"

std::wstring encode_html_entity(wchar_t const *ptr, size_t len)
{
	std::wstringstream out;
	if (ptr) {
		while (len > 0) {
			wchar_t c = *ptr;
			if (c == L'&') {
				static wchar_t const *p = L"&amp;";
				sswrite(&out, p);
			} else if (c == L'<') {
				static wchar_t const *p = L"&lt;";
				sswrite(&out, p);
			} else if (c == L'>') {
				static wchar_t const *p = L"&gt;";
				sswrite(&out, p);
			} else if (c == L'\"') {
				static wchar_t const *p = L"&quot;";
				sswrite(&out, p);
			} else if (c == L'\'') {
				static wchar_t const *p = L"&apos;";
				sswrite(&out, p);
			} else {
				out.put(c);
			}
			ptr++;
			len--;
		}
	}
	return out.str();
}

