
#ifndef __SSWRITE_H
#define __SSWRITE_H


#include <vector>
#include <sstream>


inline void sswrite(std::wstringstream *out, wchar_t c)
{
	out->put(c);
}

inline void sswrite(std::wstringstream *out, wchar_t const *p)
{
	out->write(p, (std::streamsize)wcslen(p));
}

inline void sswrite(std::wstringstream *out, wchar_t const *p, size_t l)
{
	out->write(p, (std::streamsize)l);
}

inline void sswrite(std::wstringstream *out, std::wstring const &s)
{
	sswrite(out, s.c_str(), s.size());
}

void sswritef(std::wstringstream *out, wchar_t const *f, ...);

inline void sswrite(std::stringstream *out, char c)
{
	out->put(c);
}

//

inline void sswrite(std::stringstream *out, char const *p)
{
	out->write(p, (std::streamsize)strlen(p));
}

inline void sswrite(std::stringstream *out, char const *p, size_t l)
{
	out->write(p, (std::streamsize)l);
}

inline void sswrite(std::stringstream *out, std::string const &s)
{
	sswrite(out, s.c_str(), s.size());
}

void sswritef(std::stringstream *out, char const *f, ...);


#endif
